import 'dart:async';
import '../../osam_flutter.dart';

part 'osam_route.g.dart';

@HiveType(typeId: 222)
class OsamRoute<T, A, R> {
  @HiveField(0)
  final T value;
  @HiveField(1)
  final A argument;
  @HiveField(2)
  R result;
  final completer = Completer<R>();

  void complete() {
    if (result != null) completer.complete(result);
  }

  OsamRoute(this.value, {this.argument, this.result});

  @override
  bool operator ==(other) => value == other.value;


  @override
  String toString() => 'Route is $value with result: ${result.toString}';

  @override
  int get hashCode => value.hashCode;
}
